diff -urN --exclude .git --exclude po/ --exclude '*.pyc' --exclude '.*.swp' anaconda/storage/devicelibs/mdraid.py anaconda-storage/storage/devicelibs/mdraid.py
--- anaconda/storage/devicelibs/mdraid.py	1969-12-31 18:00:00.000000000 -0600
+++ anaconda-storage/storage/devicelibs/mdraid.py	2009-02-16 16:43:11.000000000 -0600
@@ -0,0 +1,224 @@
+import iutil
+import os
+import gettext
+_ = lambda x: gettext.ldgettext("anaconda", x)
+
+class MDRaidError(Exception):
+    pass
+
+def getRaidLevels():
+    avail = []
+    try:
+        f = open("/proc/mdstat", "r")
+    except:
+        pass
+    else:
+        for l in f.readlines():
+            if not l.startswith("Personalities"):
+                continue
+
+            lst = l.split()
+
+            for lev in ["RAID0", "RAID1", "RAID5", "RAID6", "RAID10"]:
+                if "[" + lev + "]" in lst or "[" + lev.lower() + "]" in lst:
+                    avail.append(lev)
+
+        f.close()
+
+    avail.sort()
+    return avail
+
+raid_levels = getRaidLevels()
+
+def isRaid10(raidlevel):
+    """Return whether raidlevel is a valid descriptor of RAID10."""
+    return raidlevel in ("RAID10", "10", 10)
+
+def isRaid6(raidlevel):
+    """Return whether raidlevel is a valid descriptor of RAID6."""
+    return raidlevel in ("RAID6", "6", 6)
+
+def isRaid5(raidlevel):
+    """Return whether raidlevel is a valid descriptor of RAID5."""
+    return raidlevel in ("RAID5", "5", 5)
+
+def isRaid1(raidlevel):
+    """Return whether raidlevel is a valid descriptor of RAID1."""
+    return raidlevel in ("mirror", "RAID1", "1", 1)
+
+def isRaid0(raidlevel):
+    """Return whether raidlevel is a valid descriptor of RAID0."""
+    return raidlevel in ("stripe", "RAID0", "0", 0)
+
+def get_raid_min_members(raidlevel):
+    """Return the minimum number of raid members required for raid level"""
+    if isRaid0(raidlevel):
+        return 2
+    elif isRaid1(raidlevel):
+        return 2
+    elif isRaid5(raidlevel):
+        return 3
+    elif isRaid6(raidlevel):
+        return 4
+    elif isRaid10(raidlevel):
+        return 4
+    else:
+        raise ValueError, "invalid raidlevel in get_raid_min_members"
+
+def get_raid_max_spares(raidlevel, nummembers):
+    """Return the maximum number of raid spares for raidlevel."""
+    if isRaid0(raidlevel):
+        return 0
+    elif isRaid1(raidlevel) or isRaid5(raidlevel) or \
+         isRaid6(raidlevel) or isRaid10(raidlevel):
+        return max(0, nummembers - get_raid_min_members(raidlevel))
+    else:
+        raise ValueError, "invalid raidlevel in get_raid_max_spares"
+
+def mdcreate(device, level, disks, spares=0):
+    argv = ["--create", device, "--level", str(level)]
+    raid_devs = len(disks) - spares
+    argv.append("--raid-devices=%d" % raid_devs)
+    if spares:
+        argv.append("--spare-devices=%d" % spares)
+    argv.extend(disks)
+    
+    rc = iutil.execWithRedirect("mdadm",
+                                argv,
+                                stderr = "/dev/null",
+                                stdout = "/dev/null",
+                                searchPath=1)
+
+    if rc:
+        raise MDRaidError("mdcreate failed for %s" % device)
+
+    # mdadm insists on starting the new array, so we have to stop it here
+    #self.mddeactivate(device)
+
+def mddestroy(device):
+    rc = iutil.execWithRedirect("mdadm",
+                                ["--zero-superblock", device],
+                                stderr = "/dev/null",
+                                stdout = "/dev/null",
+                                searchPath=1)
+
+    if rc:
+        raise MDRaidError("mddestroy failed for %s" % device)
+
+def mdadd(device):
+    # XXX NOTUSED: mdadm -I is broken and dledford says it should be
+    #              avoided if possible, so we used mdadm -A instead
+    rc = iutil.execWithRedirect("mdadm",
+                                ["--incremental", 
+                                 "--quiet",
+                                 "--auto=yes",
+                                 device],
+                                stderr = "/dev/null",
+                                stdout = "/dev/null",
+                                searchPath=1)
+
+    if rc:
+        raise MDRaidError("mdadd failed for %s" % device)
+
+def mdactivate(device, members=[], super_minor=None, uuid=None):
+    if super_minor is None and not uuid:
+        raise ValueError("mdactivate requires either a uuid or a super-minor")
+    
+    if uuid:
+        identifier = "--uuid=%s" % uuid
+    elif super_minor is not None:
+        identifier = "--super-minor=%d" % super_minor
+    else:
+        identifier = ""
+
+    filename = None
+    if members:
+        from tempfile import mkstemp
+        (fd, filename) = mkstemp(prefix="%s_devices." % device,
+                                     dir="/tmp",
+                                     text=True)
+        os.write(fd, "DEVICE %s\n" % " ".join(members))
+        config_arg = "--config=%s" % filename
+        os.close(fd)
+        del mkstemp
+    else:
+        config_arg = ""
+
+    rc = iutil.execWithRedirect("mdadm",
+                                ["--assemble",
+                                 config_arg,
+                                 device,
+                                 identifier,
+                                 "--auto=md",
+                                 "--update=super-minor"],
+                                stderr = "/dev/null",
+                                stdout = "/dev/null",
+                                searchPath=1)
+
+    if filename and os.access(filename, os.R_OK):
+        try:
+            os.unlink(filename)
+        except OSError, e:
+            log.debug("unlink of %s failed: %s" % (filename, e))
+
+    if rc:
+        raise MDRaidError("mdactivate failed for %s" % device)
+
+
+def mddeactivate(device):
+    rc = iutil.execWithRedirect("mdadm",
+                                ["--stop", device],
+                                stderr = "/dev/null",
+                                stdout = "/dev/null",
+                                searchPath=1)
+
+    if rc:
+        raise MDRaidError("mddeactivate failed for %s" % device)
+
+def mdexamine(device):
+    # XXX NOTUSED: we grab metadata from udev, which ran 'mdadm -E --export'
+    #
+    # FIXME: this will not work with version >= 1 metadata
+    #
+    # We should use mdadm -Eb or mdadm -E --export for a more easily
+    # parsed output format.
+    lines = iutil.execWithCapture("mdadm",
+                                  ["--examine", device],
+                                  stderr="/dev/null").splitlines()
+
+    info = {
+            'major': "-1",
+            'minor': "-1",
+            'uuid' : "",
+            'level': -1,
+            'nrDisks': -1,
+            'totalDisks': -1,
+            'mdMinor': -1,
+        }
+
+    for line in lines:
+        (key, sep, val) = line.strip().partition(" : ")
+        if not sep:
+            continue
+        if key == "Version":
+            (major, sep, minor) = val.partition(".")
+            info['major'] = major
+            info['minor'] = minor
+        elif key == "UUID":
+            info['uuid'] = val.split()[0]
+        elif key == "Raid Level":
+            info['level'] = int(val[4:])
+        elif key == "Raid Devices":
+            info['nrDisks'] = int(val)
+        elif key == "Total Devices":
+            info['totalDisks'] = int(val)
+        elif key == "Preferred Minor":
+            info['mdMinor'] = int(val)
+        else:
+            continue
+
+    if not info['uuid']:
+        raise MDRaidError("UUID missing from device info")
+
+    return info
+
diff -urN --exclude .git --exclude po/ --exclude '*.pyc' --exclude '.*.swp' anaconda/storage/devicelibs/swap.py anaconda-storage/storage/devicelibs/swap.py
--- anaconda/storage/devicelibs/swap.py	1969-12-31 18:00:00.000000000 -0600
+++ anaconda-storage/storage/devicelibs/swap.py	2009-02-12 18:59:46.000000000 -0600
@@ -0,0 +1,103 @@
+# swap.py
+# Python module for managing swap devices.
+#
+# Copyright (C) 2009  Red Hat, Inc.
+#
+# This copyrighted material is made available to anyone wishing to use,
+# modify, copy, or redistribute it subject to the terms and conditions of
+# the GNU General Public License v.2, or (at your option) any later version.
+# This program is distributed in the hope that it will be useful, but WITHOUT
+# ANY WARRANTY expressed or implied, including the implied warranties of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
+# Public License for more details.  You should have received a copy of the
+# GNU General Public License along with this program; if not, write to the
+# Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+# 02110-1301, USA.  Any Red Hat trademarks that are incorporated in the
+# source code or documentation are not subject to the GNU General Public
+# License and may only be used or replicated with the express permission of
+# Red Hat, Inc.
+#
+# Red Hat Author(s): Dave Lehman <dlehman@redhat.com>
+#
+import iutil
+import gettext
+_ = lambda x: gettext.ldgettext("anaconda", x)
+
+from errors import *
+
+def mkswap(device, label=''):
+    argv = []
+    if label:
+        argv.extend(["-L", label])
+    argv.append(device)
+
+    rc = iutil.execWithRedirect("mkswap", argv,
+                                stderr = "/dev/null",
+                                stdout = "/dev/null",
+                                searchPath=1)
+
+    if rc:
+        raise SwapError("mkswap failed for '%s'" % device)
+
+def swapon(device, priority=None):
+    pagesize = resource.getpagesize()
+    buf = None
+    if pagesize > 2048:
+        num = pagesize
+    else:
+        num = 2048
+    try:
+        fd = os.open(device, os.O_RDONLY)
+        buf = os.read(fd, num)
+    except:
+        pass
+    finally:
+        try:
+            os.close(fd)
+        except:
+            pass
+
+    if buf is not None and len(buf) == pagesize:
+        sig = buf[pagesize - 10:]
+        if sig == 'SWAP-SPACE':
+            raise OldSwapError
+        if sig == 'S1SUSPEND\x00' or sig == 'S2SUSPEND\x00':
+            raise SuspendError
+
+    argv = []
+    if 0 <= priority <= 32767:
+        argv.extend(["-p", priority])
+    argv.append(device)
+        
+    rc = iutil.execWithRedirect("swapon",
+                                argv,
+                                stderr = "/dev/null",
+                                stdout = "/dev/null",
+                                searchPath=1)
+
+    if rc:
+        raise SwapError("swapon failed for '%s'" % device)
+
+def swapoff(device):
+    rc = iutil.execWithRedirect("swapoff", [device],
+                                stderr = "/dev/null",
+                                stdout = "/dev/null",
+                                searchPath=1)
+
+    if rc:
+        raise SwapError("swapoff failed for '%s'" % device)
+
+def swapstatus(device):
+    lines = open("/proc/swaps").readlines()
+    status = False
+    for line in lines:
+        if not line.strip():
+            continue
+            
+        if line.split()[0] == device:
+            status = True
+            break
+
+    return status
+
+
